Bug 1168914 - Review Request: xrootd-compat - Extended ROOT file server - compat version
Summary: Review Request: xrootd-compat - Extended ROOT file server - compat version
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Adrien Devresse
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-11-28 12:08 UTC by Mattias Ellert
Modified: 2015-02-24 13:52 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-24 13:52:55 UTC
Type: ---
adev88: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Mattias Ellert 2014-11-28 12:08:18 UTC
Spec URL: http://www.grid.tsl.uu.se/review/xrootd-compat.spec
SRPM URL: http://www.grid.tsl.uu.se/review/xrootd-compat-3.3.6-1.fc20.src.rpm

Description:
This package provides a parallel installable version 3.x of xrootd libraries and servers as a compat package in order to allow the xrootd package to be updated to version 4.x without causing incompatibilities for existing installations.

It is intended for EPEL 5 and 6 and Fedora 19 and 20.

Fedora Account System Username: ellert

Comment 1 Adrien Devresse 2014-12-09 13:35:42 UTC
Hi Mattias,

i'm taking care of it.

Comment 2 Adrien Devresse 2014-12-09 16:08:17 UTC
Review for xrootd-compat 3.3.6-1

Builds :

EPEL6
http://koji.fedoraproject.org/koji/taskinfo?taskID=8329200

EPEL5 
http://koji.fedoraproject.org/koji/taskinfo?taskID=8329336

F20
http://koji.fedoraproject.org/koji/taskinfo?taskID=8329273





[FAIL] : rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.[1]

rpmlint /var/lib/mock/epel-6-x86_64/result/*.rpm
xrootd-compat.src: I: enchant-dictionary-not-found en_US
xrootd-compat.src:148: E: files-attr-not-set
xrootd-compat.src:149: E: files-attr-not-set
xrootd-compat.src:150: E: files-attr-not-set
xrootd-compat.src:151: E: files-attr-not-set
xrootd-compat.src:154: E: files-attr-not-set
xrootd-compat.src:155: E: files-attr-not-set
xrootd-compat.src:156: E: files-attr-not-set
xrootd-compat.src:157: E: files-attr-not-set
xrootd-compat.src:158: E: files-attr-not-set
xrootd-compat.src:159: E: files-attr-not-set
xrootd-compat.src:160: E: files-attr-not-set
xrootd-compat.src:161: E: files-attr-not-set
xrootd-compat.src:163: E: files-attr-not-set
xrootd-compat.src:164: E: files-attr-not-set
xrootd-compat.src:165: E: files-attr-not-set
xrootd-compat.src:166: E: files-attr-not-set
xrootd-compat.src:169: E: files-attr-not-set
xrootd-compat.src:170: E: files-attr-not-set
xrootd-compat.src:171: E: files-attr-not-set
xrootd-compat.src:172: E: files-attr-not-set
xrootd-compat.src:173: E: files-attr-not-set
xrootd-compat.src:176: E: files-attr-not-set
xrootd-compat.src:177: E: files-attr-not-set
xrootd-compat.src:178: E: files-attr-not-set
xrootd-compat.src:179: E: files-attr-not-set
xrootd-compat.src:180: E: files-attr-not-set
xrootd-compat.src:182: E: files-attr-not-set
xrootd-compat.src:183: E: files-attr-not-set
xrootd-compat.src:184: E: files-attr-not-set
xrootd-compat.x86_64: W: obsolete-not-provided xrootd
xrootd-compat.x86_64: W: no-documentation
xrootd-compat-client-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libXrdClient.so.1.0.1 exit@GLIBC_2.2.5
xrootd-compat-client-libs.x86_64: W: no-documentation
xrootd-compat-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libXrdAppUtils.so.0.0.1 exit@GLIBC_2.2.5
xrootd-compat-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libXrdMain.so.1.0.0 exit@GLIBC_2.2.5
xrootd-compat-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libXrdMain.so.1.0.0 _exit@GLIBC_2.2.5
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecpwd.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecunix.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSec.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdCryptossl.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSeckrb5.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecgsi.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecsss.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecgsiAuthzVO.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecgsiGMAPDN.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdSecgsiGMAPLDAP.so
xrootd-compat-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdCksCalczcrc32.so
xrootd-compat-server-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libXrdServer.so.1.0.0 _exit@GLIBC_2.2.5
xrootd-compat-server-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libXrdXrootd.so.1.0.1 _exit@GLIBC_2.2.5
xrootd-compat-server-libs.x86_64: W: no-documentation
xrootd-compat-server-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdPss.so
xrootd-compat-server-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdXrootd.so
xrootd-compat-server-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libXrdBwm.so
6 packages and 0 specfiles checked; 29 errors, 24 warnings.


The main issues :
	-> devel-file-in-non-devel-packag
		-> if xrootd compat gives xrootd compatibility for xrootd3 binary apps, the libraries should not overlap with the xrootdv4 devel package.
			Are these libraries plugins ? If yes, do they have suffix in v4 ?
				
Minors:
	-> shared-lib-calls-exit
	-> no-documentation
        -> files-attr-not-set


[PASS] : The package must be named according to the Package Naming Guidelines .
[PASS] : The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
[FAIL] : The package must meet the Packaging Guidelines .

	-> the unversionned so are packaged and override the xrootd-devel package

[PASS] : The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[PASS] : The License field in the package spec file must match the actual license. [3]

cat xrootd-3.3.6/LICENSE 
"Copyright (c) 2005-2012, Board of Trustees of the Leland Stanford, Jr. University.\n"
"Produced under contract DE-AC02-76-SF00515 with the US Department of Energy.      \n"
"All rights reserved. The copyright holder's institutional names may not be used to\n"
"endorse or promote products derived from this software without specific prior     \n"
"written permission.\n\n"
"This file is part of the XRootD software suite.                          \n\n"
"XRootD is free software: you can redistribute it and/or modify it under the terms \n"
"of the GNU Lesser General Public License as published by the Free Software        \n"
"Foundation, either version 3 of the License, or (at your option) any later version.\n\n"
"XRootD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;\n"
"without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR  \n"
"PURPOSE.  See the GNU Lesser General Public License for more details.            \nn"
"You should have received a copy of the GNU Lesser General Public License along    \n"
"with XRootD in a file called COPYING.LESSER (LGPL license) and file COPYING (GPL  \n"
"license).  If not, see <http://www.gnu.org/licenses/>.\n\n"
"Prior to September 2nd, 2012 the XRootD software suite was licensed under a\n"
"modified BSD license (see file COPYING.BSD).  This applies to all code that\n"
"was in the XRootD git repository prior to that date.\n"



[PASS] : If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
[PASS] : The spec file must be written in American English. [5]
[PASS] : The spec file for the package MUST be legible. [6]
[PASS] : The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.


06656d919f5296bcf49953e97b1f3d1cf601c9a1d676945529032fa0046d7217  xrootd-3.3.6.tar.gz
06656d919f5296bcf49953e97b1f3d1cf601c9a1d676945529032fa0046d7217  xrootd-compat-3.3.6-1.fc20.x86_64/xrootd-3.3.6.tar.gz


[PASS] : The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
[N/A] : If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
[PASS] : All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[N/A] : The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
[PASS] : Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
[N/A] : Packages must NOT bundle copies of system libraries.[11]
[N/A] : If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
[N/A] : A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
[PASS] : A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
[PASS] : Permissions on files must be set properly. Executables should be set with executable permissions, for example. [15]
[N/A] : Each package must consistently use macros. [16]
[PASS] : The package must contain code, or permissible content. [17]
[N/A] : Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
[PASS] : If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
[N/A] : Static libraries must be in a -static package. [19]
[PASS] : Development files must be in a -devel package. [20]


	-> compat package no devel files

[N/A] : In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} [21]

[N/A] : Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[19]
[N/A] : Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
[PASS] : Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
[PASS] : All filenames in rpm packages must be valid UTF-8. [24]



[PASS] : If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [25]
	-> LGPLv3 file

[N/A] : The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [26]
[PASS] : The reviewer should test that the package builds in mock. [27]
[PASS] : The package should compile and build into binary rpms on all supported architectures. [28]
[PASS] : The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[N/A] : If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [29]
[PASS] : Usually, subpackages other than devel should require the base package using a fully versioned dependency. [21]
[N/A] : The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [30]
[PASS] : If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [31]
[PASS] : your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]

	-> ref non compat pkg for man page



Blocking issues :
	- Clarification needed about transition xrootd 3 - > xrootd 4 and devel package.
        - Fix rpmlint problems

Comments :
	The src package provided for the review is incompatible for EL5. ( not md5 )

Comment 3 Mattias Ellert 2014-12-10 12:41:06 UTC
(In reply to Adrien Devresse from comment #2)

> Blocking issues :
> - Clarification needed about transition xrootd 3 - > xrootd 4 and devel package
> - Fix rpmlint problems

There are no file conflicts between xrootd-compat and xrootd >= 1:4.1.0. For earler versions there were conflicts due to the plugins, but starting with version 4.1.0 the plugins have versioned names like libXrdSec-4.so. E.g.:

$ rpm -q -l xrootd-libs
/usr/lib64/libXrdAppUtils.so.1
/usr/lib64/libXrdAppUtils.so.1.0.0
/usr/lib64/libXrdCksCalczcrc32-4.so
/usr/lib64/libXrdCrypto.so.1
/usr/lib64/libXrdCrypto.so.1.0.0
/usr/lib64/libXrdCryptoLite.so.1
/usr/lib64/libXrdCryptoLite.so.1.0.0
/usr/lib64/libXrdCryptossl-4.so
/usr/lib64/libXrdSec-4.so
/usr/lib64/libXrdSecgsi-4.so
/usr/lib64/libXrdSecgsiAUTHZVO-4.so
/usr/lib64/libXrdSecgsiGMAPDN-4.so
/usr/lib64/libXrdSecgsiGMAPLDAP-4.so
/usr/lib64/libXrdSeckrb5-4.so
/usr/lib64/libXrdSecpwd-4.so
/usr/lib64/libXrdSecsss-4.so
/usr/lib64/libXrdSecunix-4.so
/usr/lib64/libXrdUtils.so.2
/usr/lib64/libXrdUtils.so.2.0.0
/usr/share/doc/xrootd-libs
/usr/share/doc/xrootd-libs/COPYING
/usr/share/doc/xrootd-libs/COPYING.BSD
/usr/share/doc/xrootd-libs/COPYING.LGPL
/usr/share/doc/xrootd-libs/LICENSE

$ rpm -qlp xrootd-compat-libs-3.3.6-1.fc20.x86_64.rpm
/usr/lib64/libXrdAppUtils.so.0
/usr/lib64/libXrdAppUtils.so.0.0.1
/usr/lib64/libXrdCksCalczcrc32.so
/usr/lib64/libXrdCksCalczcrc32.so.1
/usr/lib64/libXrdCksCalczcrc32.so.1.0.0
/usr/lib64/libXrdCrypto.so.0
/usr/lib64/libXrdCrypto.so.0.0.1
/usr/lib64/libXrdCryptoLite.so.0
/usr/lib64/libXrdCryptoLite.so.0.0.1
/usr/lib64/libXrdCryptossl.so
/usr/lib64/libXrdCryptossl.so.1
/usr/lib64/libXrdCryptossl.so.1.0.0
/usr/lib64/libXrdMain.so.1
/usr/lib64/libXrdMain.so.1.0.0
/usr/lib64/libXrdSec.so
/usr/lib64/libXrdSec.so.0
/usr/lib64/libXrdSec.so.0.0.1
/usr/lib64/libXrdSecgsi.so
/usr/lib64/libXrdSecgsi.so.0
/usr/lib64/libXrdSecgsi.so.2.0.0
/usr/lib64/libXrdSecgsiAuthzVO.so
/usr/lib64/libXrdSecgsiAuthzVO.so.0
/usr/lib64/libXrdSecgsiAuthzVO.so.1.0.0
/usr/lib64/libXrdSecgsiGMAPDN.so
/usr/lib64/libXrdSecgsiGMAPDN.so.0
/usr/lib64/libXrdSecgsiGMAPDN.so.1.0.0
/usr/lib64/libXrdSecgsiGMAPLDAP.so
/usr/lib64/libXrdSecgsiGMAPLDAP.so.0
/usr/lib64/libXrdSecgsiGMAPLDAP.so.1.0.0
/usr/lib64/libXrdSeckrb5.so
/usr/lib64/libXrdSeckrb5.so.1
/usr/lib64/libXrdSeckrb5.so.1.0.0
/usr/lib64/libXrdSecpwd.so
/usr/lib64/libXrdSecpwd.so.1
/usr/lib64/libXrdSecpwd.so.1.0.0
/usr/lib64/libXrdSecsss.so
/usr/lib64/libXrdSecsss.so.1
/usr/lib64/libXrdSecsss.so.1.0.0
/usr/lib64/libXrdSecunix.so
/usr/lib64/libXrdSecunix.so.1
/usr/lib64/libXrdSecunix.so.1.0.0
/usr/lib64/libXrdUtils.so.1
/usr/lib64/libXrdUtils.so.1.0.2
/usr/share/doc/xrootd-compat-libs
/usr/share/doc/xrootd-compat-libs/COPYING
/usr/share/doc/xrootd-compat-libs/COPYING.BSD
/usr/share/doc/xrootd-compat-libs/COPYING.LGPL
/usr/share/doc/xrootd-compat-libs/LICENSE

This issue was the reason why it was not possible to create a compat package before xrootd 4.1.0 was released and is the reason for why the conflicts in the xrootd-compat package says < 1:4.1.0.

The unversioned .so files in the xrootd-compat are all plugins and do not conflict with xrootd >= 1:4.1.0 since there the plugins have versioned names. The xrootd-compat does not provide any -devel packages, so there are no conflicts with the unversioned .so files in xrootd's -devel packages.

rpmlint:

 - E: files-attr-not-set

It seems you have been running rpmlint on RHEL - which is fine. But the rpmlint on RHEL is of course older than the latest version, and therefore runs checks against older versions of the guidelines. This complaint is about not having a %defattr in the %files sections. The current guidelines say:

http://fedoraproject.org/wiki/Packaging:Guidelines#File_Permissions

"In the past (pre rpm 4.4), it was necessary to have a %defattr section at the beginning of each %files section, but this is now the default and no longer necessary to explicitly include."

$ rpm -q rpm
rpm-4.4.2.3-34.el5

I.e. the rpm version on RHEL 5 is new enough to handle the file attributes correctly by default without %defattr. Therefore there is no need to use the old packaging guidlines in this case. (You still need to use some old guidelines to be compatible with RHEL 5 like having a BuildRoot tag, and cleaning the buildroot in the %install section and having a %clean section - these are all there in the xrootd-compat specfile.)

 - W: obsolete-not-provided xrootd

This is intentional to make the upgrade behave properly.

 - W: shared-lib-calls-exit

I can't do much about that...

 - W: no-documentation

The license files are in the xrootd-compat-libs package and the other packages Requires that one. The doxygen API documentation is not generated in the xrootd-compat package since it doesn't make sense without the -devel packages.

 - W: devel-file-in-non-devel-package

The .so symlinks included are all plugins that are loaded at runtime.

Comment 4 Adrien Devresse 2014-12-10 15:02:27 UTC
> There are no file conflicts between xrootd-compat and xrootd >= 1:4.1.0. For earler versions there were conflicts due to the plugins, but starting with version 4.1.0 the plugins have versioned names like libXrdSec-4.so. E.g.:

Ok, this is exactly what I wanted to verify.


Concerning the rpmlint warnings, I wanted only to signal them. You are right, you can not do much about them. 


Package accepted :)

Comment 5 Mattias Ellert 2014-12-10 15:32:59 UTC
Many thanks for the review!

New Package SCM Request
=======================
Package Name: xrootd-compat
Short Description: Extended ROOT file server - compat version
Owners: ellert
Branches: f19 f20 el5 el6
InitialCC:

Comment 6 Gwyn Ciesla 2014-12-12 14:05:24 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.